Remote issue URL:
Description: Currently, it is impossible for plugins to register custom variables to Liquid. This should be changed.

I propose the following API to register variables (Pull Request forthcoming):

<pre>{%raw%}<code class="ruby">
ChiliProject::Liquid::Variables.register "macro_list",
  "Use '{{ variables | to_list: \"Variables\" }}' to see all Liquid variables and '{{ tags | to_list: \"Tags\" }}' to see all 
of the Liquid tags."

ChiliProject::Liquid::Variables.register "tags" do
  ::Liquid::Template.tags.keys.sort
end

ChiliProject::Liquid::Variables.register "variables" do |context|
  vars = []

  vars = context.environments.first.keys.reject do |var|
    # internal variable
    var == "text"
  end if context.environments.present?
  vars += context.scopes.collect(&:keys).flatten
  vars.uniq.sort
end
</code>{%endraw%}</pre>

The API will allow to register static variables (which contain data generated during loading of the Application) 
or lazily evaluated variables. These will be evaluated every time they are used.

The main difference to Drops is that these variables can be easily overwritten and act exactly the same as 
user-defined variables.

Associated revisions
2008-03-07 06:15 pm - Jean-Philippe Lang 
Translations (closes #789, #790, #798, #803, #809):
* Danish added (Mads Vestergaard)
* Polish updated (Mariusz Olejnik)
* Finnish updated (Antti PerkiÃ¶mÃ¤ki)
* Simplified Chinese updated (chaoqun zou)
* Traditional Chinese updated (shortie lo)

git-svn-id: http://redmine.rubyforge.org/svn/trunk@1204 e93f8b46-1217-0410-a6f0-8f06a7374b81

2012-01-05 11:36 pm - Holger Just 
[#790] Register variables with an API
2012-01-05 11:36 pm - Holger Just 
[#790] Add filter to output an array into an unordered list

2012-01-05 11:36 pm - Holger Just 
[#790] Replace TagList and VariableList tags with variables

2012-01-05 11:36 pm - Holger Just 
[#790] Test the lazy variables

History
2011-12-26 01:14 pm - Holger Just
See the pull request at https://github.com/chiliproject/chiliproject/pull/147

It would be great if somebody could quickly review it if that is the concept we would like to follow.

Basically, it does three things:

# It adds an API to register variables which can be either static or lazily evaluated
# It adds a @to_list@ filter which formats all elements of an array as an unordered list
# It removes the @variable_list@ and @tag_list@ tags in favor of variables formatted with the new filter

2011-12-26 03:34 pm - Holger Just
- Status changed from Open to Ready for review

2012-01-05 10:47 pm - Holger Just
- Status changed from Ready for review to Closed

I just merged the pull request.
